/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-jsk-recognition-msgs-0.3.6-0raring-20150911-0900/msg/BoundingBoxMovement.msg
 *
 */


#ifndef JSK_RECOGNITION_MSGS_MESSAGE_BOUNDINGBOXMOVEMENT_H
#define JSK_RECOGNITION_MSGS_MESSAGE_BOUNDINGBOXMOVEMENT_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>
#include <jsk_recognition_msgs/BoundingBox.h>
#include <geometry_msgs/Pose.h>
#include <geometry_msgs/PoseStamped.h>

namespace jsk_recognition_msgs
{
template <class ContainerAllocator>
struct BoundingBoxMovement_
{
  typedef BoundingBoxMovement_<ContainerAllocator> Type;

  BoundingBoxMovement_()
    : header()
    , box()
    , handle_pose()
    , destination()  {
    }
  BoundingBoxMovement_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , box(_alloc)
    , handle_pose(_alloc)
    , destination(_alloc)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef  ::jsk_recognition_msgs::BoundingBox_<ContainerAllocator>  _box_type;
  _box_type box;

   typedef  ::geometry_msgs::Pose_<ContainerAllocator>  _handle_pose_type;
  _handle_pose_type handle_pose;

   typedef  ::geometry_msgs::PoseStamped_<ContainerAllocator>  _destination_type;
  _destination_type destination;




  typedef boost::shared_ptr< ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct BoundingBoxMovement_

typedef ::jsk_recognition_msgs::BoundingBoxMovement_<std::allocator<void> > BoundingBoxMovement;

typedef boost::shared_ptr< ::jsk_recognition_msgs::BoundingBoxMovement > BoundingBoxMovementPtr;
typedef boost::shared_ptr< ::jsk_recognition_msgs::BoundingBoxMovement const> BoundingBoxMovementConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace jsk_recognition_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'jsk_recognition_msgs': ['/tmp/buildd/ros-hydro-jsk-recognition-msgs-0.3.6-0raring-20150911-0900/msg'], 'pcl_msgs': ['/opt/ros/hydro/share/pcl_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator> >
{
  static const char* value()
  {
    return "60aeb288c030d1b8a67ddeedc91812f0";
  }

  static const char* value(const ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x60aeb288c030d1b8ULL;
  static const uint64_t static_value2 = 0xa67ddeedc91812f0ULL;
};

template<class ContainerAllocator>
struct DataType< ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator> >
{
  static const char* value()
  {
    return "jsk_recognition_msgs/BoundingBoxMovement";
  }

  static const char* value(const ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator> >
{
  static const char* value()
  {
    return "Header header\n\
BoundingBox box\n\
geometry_msgs/Pose handle_pose\n\
geometry_msgs/PoseStamped destination\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: jsk_recognition_msgs/BoundingBox\n\
Header header\n\
geometry_msgs/Pose pose\n\
geometry_msgs/Vector3 dimensions #x, y and z\n\
# You can use this field to hold value such as likelihood\n\
float32 value\n\
uint32 label\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
================================================================================\n\
MSG: geometry_msgs/PoseStamped\n\
# A Pose with reference coordinate frame and timestamp\n\
Header header\n\
Pose pose\n\
";
  }

  static const char* value(const ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.box);
      stream.next(m.handle_pose);
      stream.next(m.destination);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct BoundingBoxMovement_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::jsk_recognition_msgs::BoundingBoxMovement_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "box: ";
    s << std::endl;
    Printer< ::jsk_recognition_msgs::BoundingBox_<ContainerAllocator> >::stream(s, indent + "  ", v.box);
    s << indent << "handle_pose: ";
    s << std::endl;
    Printer< ::geometry_msgs::Pose_<ContainerAllocator> >::stream(s, indent + "  ", v.handle_pose);
    s << indent << "destination: ";
    s << std::endl;
    Printer< ::geometry_msgs::PoseStamped_<ContainerAllocator> >::stream(s, indent + "  ", v.destination);
  }
};

} // namespace message_operations
} // namespace ros

#endif // JSK_RECOGNITION_MSGS_MESSAGE_BOUNDINGBOXMOVEMENT_H
